VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "Send SMS (via Nokia)"
   ClientHeight    =   3090
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   6480
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   3090
   ScaleWidth      =   6480
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton cmdPhoneInfo 
      Caption         =   "Phone Info"
      Height          =   495
      Left            =   4200
      TabIndex        =   5
      Top             =   1200
      Width           =   1215
   End
   Begin VB.CommandButton cmdSend 
      Caption         =   "Send"
      Default         =   -1  'True
      Height          =   495
      Left            =   4200
      TabIndex        =   4
      Top             =   480
      Width           =   1215
   End
   Begin VB.TextBox txtMessage 
      Height          =   1455
      Left            =   120
      MaxLength       =   160
      MultiLine       =   -1  'True
      TabIndex        =   1
      Top             =   480
      Width           =   3735
   End
   Begin VB.TextBox txtNumber 
      Height          =   375
      Left            =   120
      TabIndex        =   3
      Top             =   2400
      Width           =   3735
   End
   Begin VB.Label lblCharsLeft 
      Alignment       =   1  'Rechts
      Height          =   255
      Left            =   2760
      TabIndex        =   6
      Top             =   240
      Width           =   1095
   End
   Begin VB.Label Label2 
      Caption         =   "Message:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   240
      Width           =   1215
   End
   Begin VB.Label Label1 
      Caption         =   "Number:"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   2160
      Width           =   2535
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private bAttached As Boolean
Private WithEvents PhoneInfoEventsSuite As STTNGS3A_SLib.PhoneInfo_Suite3
Attribute PhoneInfoEventsSuite.VB_VarHelpID = -1
Private WithEvents SMSSuite As SMS3ASuiteLib.SMS_SuiteAdapter
Attribute SMSSuite.VB_VarHelpID = -1

Private Sub Form_Load()
    Dim devN As STTNGS3A_SLib.DevNotifyOpt
    ShowCharsLeft
    
    Set PhoneInfoEventsSuite = New STTNGS3A_SLib.PhoneInfo_Suite3
    PhoneInfoEventsSuite.StartListeningPhoneInfoEvents
    Call PhoneInfoEventsSuite.get_DeviceStatus(devN)
    If devN = ATTACHED Then
        bAttached = True
    End If
    If devN = REMOVED Then
        bAttached = False
    End If
End Sub

Private Sub Form_Unload(Cancel As Integer)
    PhoneInfoEventsSuite.Terminate
End Sub

Private Sub ShowCharsLeft()
    lblCharsLeft.Caption = txtMessage.MaxLength - Len(txtMessage.Text)
End Sub

Private Sub cmdPhoneInfo_Click()
    Dim info As String
    
    If Not bAttached Then
        MsgBox "Phone not connected."
        Exit Sub
    End If
    With PhoneInfoEventsSuite
        info = "Product Type: " & .ProductType & vbCrLf & _
            "Product Code: " & .ProductCode & vbCrLf & _
            "Software Version: " & .SwVersion & vbCrLf & _
            "Hardware Version: " & .HwVersion
    End With
    Call MsgBox(info, vbOKOnly, "Phone info")
End Sub

Private Sub PhoneInfoEventsSuite_BatteryNotify(ByVal bLevel As Long, ByVal bCharging As Boolean)
    'Must be implemented
End Sub

Private Sub PhoneInfoEventsSuite_DeviceNotify(ByVal val As STTNGS3A_SLib.DevNotifyOpt)
    Select Case val
        Case ATTACHED: bAttached = True
        Case DISCONNECTED: bAttached = False
        Case REMOVED: bAttached = False
        Case UNKNOWN: bAttached = False
    End Select
End Sub

Private Sub SMSSuite_ShortMsgReceived( _
    ByVal SMSMemory As SMS3ASuiteLib.SMS_MEMORY_LOCATION, _
    ByVal index As Long, _
    ByVal pSMS As SMS3ASuiteLib.ShortMessage)
        MsgBox "Message from " & pSMS.OtherEndAddress
End Sub

Private Sub SMSSuite_ShortMsgSent(ByVal pSMS As SMS3ASuiteLib.ShortMessage)
    MsgBox "Short message sent to " & pSMS.OtherEndAddress
End Sub

Private Sub SMSSuite_SMSMemoryFull( _
ByVal SMSMemory As SMS3ASuiteLib.SMS_MEMORY_LOCATION)
    'check which memory is full
    Select Case SMSMemory
        Case PHONE_MEMORY
            MsgBox "Phone SMS memory is full."
        Case SIM_MEMORY
            MsgBox "SIM SMS memory is full."
        Case DEFAULT_MEMORY
            MsgBox "Default SMS memory is full."
    End Select
End Sub

Private Sub SendSMS(ByVal Number As String, ByVal Message As String)
    Dim sms As ShortMessage
    Dim settings As ISMSSettings
    
    'error handling vars
    Dim errn As Long
    Dim errd As String
    
    'SMS settings
    Dim ParameterSetIndex As Long
    Dim ParameterSetName As String
    Dim ProtocolIdentifier As Byte
    Dim DataCodingScheme As Byte
    Dim ValidityPeriod As Byte
    Dim SCAddress As String
    
    On Error GoTo err
    
    Set SMSSuite = New SMS3ASuiteLib.SMS_SuiteAdapter
    SMSSuite.StartListeningEvents

    Set settings = SMSSuite
    ParameterSetIndex = 1
    Call settings.GetSMSParametersSet(ParameterSetIndex, ParameterSetName, _
        ProtocolIdentifier, DataCodingScheme, ValidityPeriod, SCAddress)

    'Create new SMS message
    Set sms = SMSSuite.CreateShortMsg
    sms.DataCodingScheme = DataCodingScheme
    sms.ProtocolIdentifier = ProtocolIdentifier
    sms.SCAddress = SCAddress
    sms.OtherEndAddress = Number
    sms.UserDataText = Message
    
    'Send SMS
    Call SMSSuite.Send(sms)
    GoTo finally

err:
    errn = err.Number
    errd = err.Description
    
    Dim ErrNr As SMS3ASuiteLib.NmpAdapterError
    Dim ErrStr As String
    If Not SMSSuite Is Nothing Then
        ErrNr = SMSSuite.GetLastError
    Else
        Call MsgBox(errd + " (" + CStr(errn) + ")", , "Error")
        GoTo finally
    End If
        
    Select Case ErrNr
        Case errSmsInvalidParameterSetIndex: ErrStr = "Invalid SMS parameter set index"
        Case errCommunicationError: ErrStr = "Communication error"
        Case Else: ErrStr = "Unknown error"
    End Select
    Call MsgBox(ErrStr + " (" + CStr(ErrNr) + ")", , "SMS Error")

finally:
    If Not sms Is Nothing Then Set sms = Nothing
    If Not SMSSuite Is Nothing Then
        SMSSuite.Terminate
        Set SMSSuite = Nothing
    End If
End Sub

Private Sub cmdSend_Click()
    If txtNumber.Text = "" Or txtMessage.Text = "" Then
        Call MsgBox("You must enter both number and message fields.")
    Else
        If bAttached Then
            Call SendSMS(txtNumber.Text, txtMessage.Text)
        Else
            MsgBox "Phone not connected."
        End If
    End If
End Sub

Private Sub txtMessage_Change()
    ShowCharsLeft
End Sub
